import createInstance from "./constructor";
import HttpXsDefaultProto from "./proto";
import { Get, Post, Options, Put, Delete, Patch, Head } from "./core/httpMethod";
import { toCamelCase, XsHeaders } from "./headers";
import { exectionOfSingleRequest } from "./core/request";
import XsCancel from "./cancel";
import { useRequest, define } from "./define";
import { asyncIterable } from "./asyncIterator";
import retry from "./retry";
export * from "./typedef";
export * from "./enums";
declare const xs: {
    create: typeof createInstance;
    asyncIterable: typeof asyncIterable;
    request: typeof exectionOfSingleRequest;
    XsCancel: typeof XsCancel;
    XsHeaders: typeof XsHeaders;
    resolve: {
        (): Promise<void>;
        <T>(value: T): Promise<Awaited<T>>;
        <T>(value: T | PromiseLike<T>): Promise<Awaited<T>>;
    };
    reject: <T = never>(reason?: any) => Promise<T>;
    each: typeof import("./utils").forEach;
    retry: typeof retry;
    define: typeof define;
    useRequest: typeof useRequest;
};
export { HttpXsDefaultProto, xs, retry, asyncIterable, createInstance as create, Get, Get as get, Delete, Delete as delete, Post, Post as post, Put, Put as put, Head, Head as head, Patch, Patch as patch, Options, Options as options, exectionOfSingleRequest as request, toCamelCase, XsHeaders, XsCancel, useRequest, define };
export default xs;
